#include <dos.h>             //needed for sleep()

class Stuff{};
class Nachos : public Stuff {};

//Oven - implements a conventional oven
class Oven
{
  public:
   virtual void cook(Nachos &nachos);

   //support functions that we need
   void turnOn();            //apply current
   void turnOff();           //turn off current

   void insert(Stuff &s);    //put stuff in oven
   void remove(Stuff &s);    //pull stuff out

  protected:
   float temp;
};
void Oven::cook(Nachos &nachos)
{
   //preheat oven
   turnOn();
   while (temp < 350)
   {
   }

   //now put nachos in for 15 minutes
   insert(nachos);
   sleep(15 * 60);

   //get them out and turn the oven off
   remove(nachos);
   turnOff();
}

class Microwave : public Oven {
  public:
   virtual void cook(Nachos &nachos);
   void rotateStuff(Stuff &s);
};
void Microwave::cook(Nachos &nachos)
{
   //no preheating necessary - temperature irrelevant

   //put nachos in first
   insert(nachos);
   turnOn();

   //only cook for a minute (rotate in the middle)
   sleep(30);
   rotateStuff(nachos);
   sleep(30);

   //turn the oven off first (lest your hair fall out)
   turnOff();
   remove(nachos);
}

Nachos makeNachos(Oven &oven)
{
   //get all the stuff together
   //and assemble the parts
   Nachos n;

   //now (here comes the critical part), cook it
   //(given whatever kind of oven you have)
   oven.cook(n);

   //return the results
   return n;
}