#include <iostream.h>
class Account
{
  public:
   enum Type {ACCOUNT, CHECKING, SAVINGS};
   Account(unsigned accNo, float initialBalance = 0.0)
   {
      type = ACCOUNT;        //set the run-time type
   }
   Type runtimeType()
   {
      return type;
   }
  protected:
   Type type;
};
class Checking : public Account
{
  public:
   Checking(unsigned accNo, float initialBalance = 0.0) :
      Account(accNo, initialBalance)
   {                         //set the run-time type;...
      type = CHECKING;       //... overwrite the value put there...
   }                         //... by Account's constructor
};
class Savings : public Account
{
  public:
   Savings(unsigned accNo, float initialBalance = 0.0) :
      Account(accNo, initialBalance)
   {
      type = SAVINGS;        //same as with Checking
   }
};

void fn(Account &a)
{
   switch(a.runtimeType())
   {
     case Account::SAVINGS:
        cout << "This is a savings account\n";
        break;
     case Account::CHECKING:
        cout << "This is a checking account\n";
        break;
     default:
        cout << "I don't know what this thing is\n";
  }
};
int main()
{
   Savings s(1234);
   cout << "Calling fn() with s\n";
   fn(s);
   Checking c(2345);
   cout << "Calling fn() with c\n";
   fn(c);
   return 0;
}